%define major                   10
%define libaddress_sorting      %mklibname address_sorting %{major}
%define libgpr                  %mklibname gpr %{major}
%define libgrpc_csharp_ext      %mklibname grpc_csharp_ext %{major}
%define libgrpc_unsecure        %mklibname grpc_unsecure %{major}
%define libgrpc                 %mklibname grpc %{major}
%define libupb                  %mklibname upb %{major}

%define majorpp                 1
%define libgrpcpp_alts          %mklibname grpc++_alts %{majorpp}
%define libgrpcpp_error_details %mklibname grpc++_error_details %{majorpp}
%define libgrpcpp_reflection    %mklibname grpc++_reflection %{majorpp}
%define libgrpcpp_unsecure      %mklibname grpc++_unsecure %{majorpp}
%define libgrpcpp               %mklibname grpc++ %{majorpp}
%define libgrpcpp_channelz      %mklibname grpcpp_channelz %{majorpp}

%define devname                 %mklibname %{name} -d

# Third_party abseil-cpp
%define absl_commit             df3ea785d8c30a9503321a3d35ee7d35808f190d
# Third_party benchmark
%define bench_commit            090faecb454fbd6e6e17a75ef8146acb037118d4

Name:           grpc
Version:        1.30.2
Release:        %mkrel 3
Summary:        Modern, open source, high-performance remote procedure call (RPC) framework
License:        ASL 2.0
Group:          System/Libraries
URL:            https://www.grpc.io
Source0:        https://github.com/grpc/grpc/archive/v%{version}/%{name}-%{version}.tar.gz
Source1:        https://github.com/abseil/abseil-cpp/archive/%{absl_commit}.tar.gz
Source2:        https://github.com/google/benchmark/archive/%{bench_commit}.tar.gz
Patch0:         0001-enforce-system-crypto-policies.patch
Patch4:		0004-use-shell-loop-instead-makefile-function.patch
Patch10:        grpc-1.30.0-linking.patch
BuildRequires:  gcc-c++
BuildRequires:  protobuf-compiler
BuildRequires:  gperftools-devel
BuildRequires:  pkgconfig(benchmark)
BuildRequires:  pkgconfig(protobuf) >= 3.12.0
BuildRequires:  pkgconfig(openssl) > 1.1
BuildRequires:  pkgconfig(libcares)
BuildRequires:  pkgconfig(gflags)
BuildRequires:  pkgconfig(gtest)
BuildRequires:  pkgconfig(zlib)

BuildRequires:  python3-devel
BuildRequires:  python3-setuptools
BuildRequires:  python3-cython

Requires:       %{libaddress_sorting} = %{version}-%{release}
Requires:       %{libgpr} = %{version}-%{release}
Requires:       %{libgrpc_csharp_ext} = %{version}-%{release}
Requires:       %{libgrpc_unsecure} = %{version}-%{release}
Requires:       %{libgrpc} = %{version}-%{release}
Requires:       %{libgrpcpp_error_details} = %{version}-%{release}
Requires:       %{libgrpcpp_reflection} = %{version}-%{release}
Requires:       %{libgrpcpp_unsecure} = %{version}-%{release}
Requires:       %{libgrpcpp} = %{version}-%{release}
Requires:       %{libgrpcpp_channelz} = %{version}-%{release}

%description
gRPC is a modern open source high performance RPC framework that can run in any
environment. It can efficiently connect services in and across data centers
with pluggable support for load balancing, tracing, health checking and
authentication. It is also applicable in last mile of distributed computing to
connect devices, mobile applications and browsers to backend services.

The main usage scenarios:

* Efficiently connecting polyglot services in microservices style architecture
* Connecting mobile devices, browser clients to backend services
* Generating efficient client libraries

Core Features that make it awesome:

* Idiomatic client libraries in 10 languages
* Highly efficient on wire and with a simple service definition framework
* Bi-directional streaming with http/2 based transport
* Pluggable auth, tracing, load balancing and health checking

#------------------------------------------------

%package        plugins
Summary:        gRPC protocol buffers compiler plugins
Group:          System/Libraries
Requires:       %{name} = %{version}-%{release}
Requires:       protobuf-compiler

%description    plugins
Plugins to the protocol buffers compiler to generate gRPC sources.

#------------------------------------------------

%package        cli
Summary:        gRPC protocol buffers cli
Group:          System/Libraries
Requires:       %{name} = %{version}-%{release}

%description    cli
Plugins to the protocol buffers compiler to generate gRPC sources.

#------------------------------------------------

%package -n     %{libaddress_sorting}
Summary:        Address Sorting library for gRPC
Group:          System/Libraries

%description -n %{libaddress_sorting}
Address Sorting library for gRPC.

#------------------------------------------------

%package -n     %{libgpr}
Summary:        Gpr library for gRPC
Group:          System/Libraries

%description -n %{libgpr}
Gpr library for gRPC.

#------------------------------------------------

%package -n     %{libgrpc_csharp_ext}
Summary:        gRPC Csharp ext library
Group:          System/Libraries

%description -n %{libgrpc_csharp_ext}
gRPC Csharp ext library.

#------------------------------------------------

%package -n     %{libgrpc_unsecure}
Summary:        gRPC Unsecure library
Group:          System/Libraries

%description -n %{libgrpc_unsecure}
gRPC Unsecure library.

#------------------------------------------------

%package -n     %{libgrpc}
Summary:        Main gRPC library
Group:          System/Libraries

%description -n %{libgrpc}
Main gRPC library.

#------------------------------------------------

%package -n     %{libupb}
Summary:        gRPC Upb library
Group:          System/Libraries

%description -n %{libupb}
gRPC Upb library.

#------------------------------------------------

%package -n     %{libgrpcpp_alts}
Summary:        gRPC++ ALTS library
Group:          System/Libraries

%description -n %{libgrpcpp_alts}
gRPC++ ALTS library.

#------------------------------------------------

%package -n     %{libgrpcpp_error_details}
Summary:        gRPC++ Error Details library
Group:          System/Libraries

%description -n %{libgrpcpp_error_details}
gRPC++ Error Details library.

#------------------------------------------------

%package -n     %{libgrpcpp_reflection}
Summary:        gRPC++ Reflection library
Group:          System/Libraries

%description -n %{libgrpcpp_reflection}
gRPC++ Reflection library.

#------------------------------------------------

%package -n     %{libgrpcpp_unsecure}
Summary:        gRPC++ Unsecure library
Group:          System/Libraries

%description -n %{libgrpcpp_unsecure}
gRPC++ Unsecure library.

#------------------------------------------------

%package -n     %{libgrpcpp}
Summary:        Main gRPC++ library
Group:          System/Libraries

%description -n %{libgrpcpp}
Main gRPC++ library.

#------------------------------------------------

%package -n     %{libgrpcpp_channelz}
Summary:        gRPC++ Channelz library
Group:          System/Libraries

%description -n %{libgrpcpp_channelz}
gRPC++ Channelz library.

#------------------------------------------------

%package -n     %{devname}
Summary:        gRPC library development files
Group:          Development/C++
Requires:       %{name}-cli = %{version}-%{release}
Requires:       %{name}-plugins = %{version}-%{release}
Requires:       %{libaddress_sorting} = %{version}-%{release}
Requires:       %{libgpr} = %{version}-%{release}
Requires:       %{libgrpc_csharp_ext} = %{version}-%{release}
Requires:       %{libgrpc_unsecure} = %{version}-%{release}
Requires:       %{libgrpc} = %{version}-%{release}
Requires:       %{libupb} = %{version}-%{release}
Requires:       %{libgrpcpp_error_details} = %{version}-%{release}
Requires:       %{libgrpcpp_reflection} = %{version}-%{release}
Requires:       %{libgrpcpp_unsecure} = %{version}-%{release}
Requires:       %{libgrpcpp} = %{version}-%{release}
Requires:       %{libgrpcpp_channelz} = %{version}-%{release}
Provides:       %{name}-devel = %{version}-%{release}

%description -n %{devname}
Development headers and files for gRPC libraries.

#------------------------------------------------

%package -n     python3-grpcio
Summary:        Python3 language bindings for grpc, remote procedure call (RPC) framework
Group:          Development/Python
Requires:       %{name} = %{version}-%{release}
%{?python_provide:%python_provide python3-grpcio}

%description -n python3-grpcio
Python3 bindings for gRPC library.

#------------------------------------------------

%prep
%setup -q -a1 -a2
%autopatch -p1

sed -i 's:^prefix ?= .*:prefix ?= %{_prefix}:' Makefile
sed -i 's:$(prefix)/lib:$(prefix)/%{_lib}:' Makefile
sed -i 's:^GTEST_LIB =.*::' Makefile

# prepare abseil-cpp Third_party
mv abseil-cpp-%{absl_commit}/* third_party/abseil-cpp/
rm -rf abseil-cpp-%{absl_commit}/
# prepare benchmark Third_party
mv benchmark-%{bench_commit}/* third_party/benchmark/
rm -rf benchmark-%{bench_commit}/

%build
%make_build shared plugins

# build python module
export GRPC_PYTHON_BUILD_WITH_CYTHON=True
export GRPC_PYTHON_BUILD_SYSTEM_OPENSSL=True
export GRPC_PYTHON_BUILD_SYSTEM_ZLIB=True
export GRPC_PYTHON_BUILD_SYSTEM_CARES=True
export CFLAGS="%{optflags}"
%py3_build

%install
%make_install prefix="%{buildroot}%{_prefix}"
%make_install install-grpc-cli prefix="%{buildroot}%{_prefix}"

find %{buildroot} -name '*.a' -delete

%py3_install

%files
%doc README.md
%license LICENSE
%{_datadir}/grpc/

%files cli
%doc README.md
%license LICENSE
%{_bindir}/grpc_cli

%files plugins
%doc README.md
%license LICENSE
%{_bindir}/grpc_*_plugin

%files -n %{libaddress_sorting}
%{_libdir}/libaddress_sorting.so.%{major}{,.*}

%files -n %{libgpr}
%{_libdir}/libgpr.so.%{major}{,.*}

%files -n %{libgrpc_csharp_ext}
%{_libdir}/libgrpc_csharp_ext.so.%{major}{,.*}

%files -n %{libgrpc_unsecure}
%{_libdir}/libgrpc_unsecure.so.%{major}{,.*}

%files -n %{libgrpc}
%{_libdir}/libgrpc.so.%{major}{,.*}

%files -n %{libupb}
%{_libdir}/libupb.so.%{major}{,.*}

%files -n %{libgrpcpp_alts}
%{_libdir}/libgrpc++_alts.so.%{majorpp}{,.*}

%files -n %{libgrpcpp_error_details}
%{_libdir}/libgrpc++_error_details.so.%{majorpp}{,.*}

%files -n %{libgrpcpp_reflection}
%{_libdir}/libgrpc++_reflection.so.%{majorpp}{,.*}

%files -n %{libgrpcpp_unsecure}
%{_libdir}/libgrpc++_unsecure.so.%{majorpp}{,.*}

%files -n %{libgrpcpp}
%{_libdir}/libgrpc++.so.%{majorpp}{,.*}

%files -n %{libgrpcpp_channelz}
%{_libdir}/libgrpcpp_channelz.so.%{majorpp}{,.*}

%files -n %{devname}
%{_libdir}/*.so
%{_libdir}/pkgconfig/*
%{_includedir}/grpc/
%{_includedir}/grpc++/
%{_includedir}/grpcpp/

%files -n python3-grpcio
%license LICENSE
%{python3_sitearch}/grpc/
%{python3_sitearch}/grpcio-%{version}-py%{python3_version}.egg-info


%changelog
* Fri Dec 18 2020 luigiwalser <luigiwalser> 1.30.2-3.mga8
+ Revision: 1660983
- rebuild for protobuf

* Mon Nov 30 2020 luigiwalser <luigiwalser> 1.30.2-2.mga8
+ Revision: 1650738
- rebuild for protobuf

* Mon Jul 27 2020 daviddavid <daviddavid> 1.30.2-1.mga8
+ Revision: 1609252
- new version: 1.30.2

* Thu Jul 09 2020 daviddavid <daviddavid> 1.30.1-1.mga8
+ Revision: 1603755
- new version: 1.30.1

* Tue Jun 30 2020 daviddavid <daviddavid> 1.30.0-1.mga8
+ Revision: 1600749
- new version: 1.30.0
- now main libmajor is 10

* Tue Apr 21 2020 daviddavid <daviddavid> 1.28.1-1.mga8
+ Revision: 1570281
- new version: 1.28.1

* Tue Feb 18 2020 daviddavid <daviddavid> 1.27.2-2.mga8
+ Revision: 1541144
- new version: 1.27.2
- new version: 1.27.1
- new version: 1.27.0
+ umeabot <umeabot>
- Mageia 8 Mass Rebuild

* Thu Dec 19 2019 daviddavid <daviddavid> 1.26.0-1.mga8
+ Revision: 1468992
- new version: 1.26.0
- now libmajor is 9
- new version: 1.22.0
+ tv <tv>
- new release: 1.24.2
- rebuild with python 3.8
+ wally <wally>
- add upstream patches to fix build with glibc 2.30 and gcc9

* Sun Jun 30 2019 daviddavid <daviddavid> 1.20.1-1.mga8
+ Revision: 1416257
- new version: 1.20.1

* Wed Apr 17 2019 daviddavid <daviddavid> 1.20.0-1.mga7
+ Revision: 1391867
- new version: 1.20.0

* Mon Apr 01 2019 daviddavid <daviddavid> 1.19.0-1.mga7
+ Revision: 1384665
- new version: 1.19.0

* Mon Apr 01 2019 daviddavid <daviddavid> 1.18.0-1.mga7
+ Revision: 1384346
- initial package grpc

